(function($) {
  // Add location to the map
  Drupal.behaviors.nodeFieldGmapEdit = {
    attach: function(context, settings) {
      var mapData = settings.nodeFieldGmapEdit;
      var latLon = new google.maps.LatLng(mapData.lat, mapData.lon);
      var mapOptions = {
        zoom: mapData.zoom,
        center: latLon,
        mapTypeId: google.maps.MapTypeId.ROADMAP
      };
      var map = new google.maps.Map(document.getElementById(mapData.id), mapOptions);
      if (mapData.marker) {
        var marker = new google.maps.Marker({
          position: latLon,
          map: map,
        });
        Drupal.settings.nodeFieldGmap = {marker: marker};
        var infowindow = new google.maps.InfoWindow({
          content: '<div style="overflow:hidden;">' + mapData.description + '</div>',
        });
        google.maps.event.addListener(marker, 'click', function() {
          infowindow.open(map, marker);
        });
      }
      // click map event
      google.maps.event.addListener(map, 'click', function(e) {
        if (settings.nodeFieldGmap) {
          settings.nodeFieldGmap.marker.setPosition(e.latLng);
        }
        else {
          var marker = new google.maps.Marker({
            position: e.latLng,
            map: map,
          });
          Drupal.settings.nodeFieldGmap = {marker: marker};
        }
        $(mapData.latId).val(e.latLng.lat());
        $(mapData.lonId).val(e.latLng.lng());
      });
    }
  }
}(jQuery));
