(function($) {
  // Add location to the map
  Drupal.behaviors.nodeFieldGmapView = {
    attach: function(context, settings) {
      var mapData = settings.nodeFieldGmapView;
      var latLon = new google.maps.LatLng(mapData.lat, mapData.lon);
      var mapOptions = {
        zoom: mapData.zoom,
        center: latLon,
        mapTypeId: google.maps.MapTypeId.ROADMAP
      };
      var map = new google.maps.Map(document.getElementById(mapData.id), mapOptions);
      if (mapData.marker) {
        var marker = new google.maps.Marker({
          position: latLon,
          map: map,
        });
        var infowindow = new google.maps.InfoWindow({
          content: '<div style="overflow:hidden;">' + mapData.description + '</div>',
        });
        google.maps.event.addListener(marker, 'click', function() {
          infowindow.open(map, marker);
        });
      }
    }
  }
}(jQuery));
